///////////////////////////////////////////////////
///////////////[1.1]Load Minim Library & sounds////
////////////////////(works only on computer)///////
///////////////////////////////////////////////////

import ddf.minim.*;
import ddf.minim.signals.*;
import ddf.minim.analysis.*;
import ddf.minim.effects.*;
Minim minim;
AudioSnippet whispers;
AudioSnippet whisper1;
AudioSnippet whisper2;
AudioSnippet whisper3;
AudioSnippet whisper4;

///////////////////////////////////////////////////
///[1.2]Load fake keyboard imgs & variables////////
///////////////////////////////////////////////////

PImage verticalKeyboard;
int counter=0;
int numberOfLetters=2;
int keyy=480;
PImage name;

///////////////////////////////////////////////////
///////////////[1.3]Load Screen Images/////////////
///////////////////////////////////////////////////

PImage opening;
PImage reed_img;
PImage login;
PImage navigation;
PImage general_map;
PImage dig_map;
PImage augmented;
PImage single_reed;
PImage single_reed_glow;
PImage yes_no;
PImage no_glow;
PImage yes_glow;

///////////////////////////////////////////////////
///[1.4]Load buttons' images & variables///////////
///////////////////////////////////////////////////

PImage map_symbol;
PImage plant_symbol;
PImage see_symbol;
PImage plant_glow;
PImage see_glow;
PImage map_glow;
PImage start_glow;
PImage imhere;
PImage imhere_small;
PImage login_button;
PImage start_button;
boolean map_button=false;
boolean see_button=false;
boolean plant_button=false;
boolean added_reed=false;

///////////////////////////////////////////////////
///[1.5]Load animations images & variables/////////
///////////////////////////////////////////////////
/*"dig here" & "speak here"*/

int digx=1;
int frame=0;
PImage dig_frame;
int holeX=200;
int holeY=50;

/*"you are here" for the map*/

int imhereY =1;
boolean imhereUP=true;

/*reeds' animation*/

int reed_frame=1;
int born_reed_frame=1;
int thisreedX=0;
int thisreedY=0;
PImage animated_reed;
PImage birthing_reed;
boolean present_reed1=true;
boolean present_reed2=true;
boolean present_reed3=true;
boolean present_reed4=true;
boolean present_reed5=true;
boolean start_reed_animation=false;
boolean start_born_reed_animation=false;
boolean digmade=false;

///////////////////////////////////////////////////
///[1.6]Assign numbers to levels///////////////////
///////////////////////////////////////////////////

int level=0;
int login_level=1;
int see_level=2;
int augmented_level=3;
int map_level=4;
int plant_level=5;
int born_reed=6;
int fade=0;

///////////////////////////////////////////////////
///[1.7]Weather/Color variable/////////////////////
///////////////////////////////////////////////////

color weather = color(255);

///////////////////////////////////////////////////
///[1.8]Load reeds' location function//////////////
///////////////////////////////////////////////////

Reed reed[];

void setup () {

  smooth();
  size (320,480);

  ///////////////////////////////////////////////////
  ///[2.1]Load sounds////////////////////////////////
  ///////////////////////////////////////////////////

  minim = new Minim(this);
  whispers = minim.loadSnippet("whispers.wav");
  whisper1 = minim.loadSnippet("whisper1.wav");
  whisper2 = minim.loadSnippet("whisper2.wav");
  whisper3 = minim.loadSnippet("whisper3.wav");
  whisper4 = minim.loadSnippet("whisper4.wav");

  ///////////////////////////////////////////////////
  ///[2.2]Load images////////////////////////////////
  ///////////////////////////////////////////////////

  verticalKeyboard = loadImage ("keyboard.png");
  opening= loadImage ("prima_foggy.jpg");
  login= loadImage ("login_foggy.jpg");
  name=loadImage("name.png");
  navigation= loadImage ("radar_map.jpg");
  augmented= loadImage ("navigation_aug_foggy.jpg");
  dig_map= loadImage ("dig_map.jpg");
  map_symbol= loadImage ("map_symbol.png");
  see_symbol= loadImage ("see_symbol.png");
  plant_symbol= loadImage ("plant_symbol.png");
  plant_glow=loadImage ("plant_glow.png");
  see_glow=loadImage ("see_glow.png");
  map_glow=loadImage ("map_glow.png");
  start_glow=loadImage ("start_glow.png");
  imhere=loadImage("imhere.png");
  imhere_small=loadImage ("imhere_small.png");
  single_reed=loadImage("single_reed.png");
  single_reed_glow=loadImage("single_reed_glow.png");
  yes_no=loadImage ("yes_no.png");
  no_glow=loadImage ("no_glow.png");
  yes_glow=loadImage ("yes_glow.png");
  reed_img=loadImage("reed2.png");
  login_button=loadImage("login_button.png");
  start_button=loadImage("start_button.png");
}
void draw () {
  background (255);

  ///////////////////////////////////////////////////
  //[3]Levels (application's different screens)//////
  ///////////////////////////////////////////////////

  if (level==0) {
    tint (weather, fade);
    fade+=10;
    image (opening,0,0);
    image (opening,0,0);
    if (mouseX>30 &&mouseX<130 && mouseY>420 && mouseY<470) {
      image (login_button,0,0);
    }
    if (mouseX>180 &&mouseX<300 && mouseY>420 && mouseY<470) {
      image (start_button,0,0);
    }
  }
  if (level==login_level) {
    tint(weather, fade);
    fade+=10;
    image (login,0,0);
  }
  if (level==see_level) {
    tint(weather, fade);
    fade+=10;
    image (navigation,0,0);

    ///////////////////////////////////////////////////
    //[3.1]Place planted reeds on the screen///////////
    //(this prototype doesn't use real gps location)///
    ///////////////////////////////////////////////////

    if(present_reed1==true) {
      image (single_reed, 100,0);
    } 
    if(present_reed2==true) {
      image (single_reed, 30,100);
    }
    if(present_reed3==true) {
      image (single_reed, 200,50);
    }
    if (added_reed==true) {
      if(present_reed4==true) {
        image (single_reed, 85,200);
        if (mouseX>140 && mouseX<160 && mouseY>200 && mouseY<400) {
          image (single_reed_glow, 85,200);
        }
      }
    }
    imhere_animate ();
    plant_button=true;
    map_button=true;
  }

  if (level==augmented_level) {
    tint(weather, fade);
    fade+=10;
    image (augmented,0,0);
  }
  if (level==map_level) {

    tint(weather, fade);
    fade+=10;

    ///////////////////////////////////////////////////
    //[3.2]Load map functions (see map sketch)/////////
    ///////////////////////////////////////////////////

    updateBackground();
    drawBackground();
    for (int i = 0; i<reed.length; i++) {
      reed[i].paint();
    }
    see_button=true;
  }

  if (level==plant_level) {
    tint(weather, fade);
    fade+=10;
    image (dig_map, 0,0);
    dig_indications ();
    see_button=true;

    ///////////////////////////////////////////////////
    //[3.3]Make an ellipse to simulate digging/////////
    ///////////////////////////////////////////////////

    if (mousePressed==true && fade>=255) {
      noStroke();
      fill(0);
      ellipse(150,360, mouseX-100,50);

      ///////////////////////////////////////////////////
      //[3.4]When the dig is made start growing reed/////
      ///////////////////////////////////////////////////

      if (mouseX>=300) {
        digmade=true;
        born_reed_frame=1;
        holeX=200;
        holeY=50;
      }
    }
    if (mousePressed==false && fade>=255 && digmade==true) {
      level=born_reed;
      reed_frame =1;
    }
  }
  if (level==born_reed) {
    tint(weather, fade);
    fade+=10;
    image (dig_map, 0,0);
    ellipse(150,360, holeX,holeY);
    start_born_reed_animation=true;

    if (start_born_reed_animation==true) {

      ///////////////////////////////////////////////////
      //[3.5]Birthing reed animation/////////////////////
      ///////////////////////////////////////////////////

      if (born_reed_frame<=30) { 
        birthing_reed= loadImage (("b"+ born_reed_frame)+".png");
        image (birthing_reed, 85, 120);
        if(frameCount%2==0) {
          born_reed_frame+=1;
        }
      }

      ///////////////////////////////////////////////////
      //[3.6]Place the new reed//////////////////////////
      ///////////////////////////////////////////////////

      if (born_reed_frame>=30) {
        start_born_reed_animation=false;
        if (present_reed5==true) {
          image(single_reed,85,120);
        }
      }
    }
    ///////////////////////////////////////////////////
    //[3.7]Restrict the hole///////////////////////////
    ///////////////////////////////////////////////////
    if (holeY>=0) {
      holeX-=4;
      holeY-=1;
    }

    ///////////////////////////////////////////////////
    //[3.8]New reed and "approve or not" glow//////////
    ///////////////////////////////////////////////////

    if(holeY<=0) {
      image (yes_no,-10,40);
      if (mouseX>140 &&mouseX<180 && mouseY>180 && mouseY<400 && present_reed5==true) {
        image (single_reed_glow,85,120);
      }
      if (mouseX>100 &&mouseX<150 && mouseY>380 && mouseY<420) {
        image (no_glow,-10,40);
      }
      if (mouseX>180 &&mouseX<220 && mouseY>380 && mouseY<420) {
        image (yes_glow,-10,40);
      }

      see_button=true;
      digmade=false;
    }
  }
  
  ///////////////////////////////////////////////////
  //[3.9]Reeds' selection////////////////////////////
  ///////////////////////////////////////////////////
  
  if (level==see_level) {
    if(present_reed1==true) {
      if (mouseX>150 && mouseX<170 && mouseY<200) {
        image (single_reed_glow, 100,0);
      }
    }
    if(present_reed2==true) {
      if (mouseX>70 && mouseX<100 && mouseY<300 && mouseY>100) {
        image (single_reed_glow, 30,100);
      }
    }
    if(present_reed3==true) {
      if (mouseX>240 && mouseX<270 && mouseY<250 && mouseY>50) {
        image (single_reed_glow, 200,50);
      }
    }
  }
  
  ///////////////////////////////////////////////////
  //[3.10]Buttons' glow//////////////////////////////
  ///////////////////////////////////////////////////
  
  if (plant_button==true) {
    image (plant_symbol,0,10);
    if ( mouseX>220 && mouseY>440) {
      image (plant_glow,0,-5);
    }
  }
  if (map_button==true) {
    image (map_symbol,0,10);
    if ( mouseX<100 && mouseY>440) {
      image (map_glow,5,-2);
    }
  }
  if (see_button==true) {
    image (see_symbol,0,10);
    if ( mouseX<220 && mouseY>440 && mouseX>100) {
      image (see_glow,3,-10);
    }
  }
  if (level==login_level && counter>=(numberOfLetters+1)&& mouseX>120 && mouseY>270 && mouseX<190 && mouseY<300) {
    image(start_glow,0,0);
  }
  if (fade>255) {
    fade=255;
  }

  ///////////////////////////////////////////////////
  //[3.11]Keyboard up&down///////////////////////////
  ///////////////////////////////////////////////////
  
  if (level==login_level) {
    if (1 < counter && counter < (numberOfLetters+1) && keyy>280) {
      image (verticalKeyboard,0,keyy);
      keyy-=20;
    }
    if (1 < counter && counter < (numberOfLetters+1) && keyy==280) {
      image (verticalKeyboard,0,280);
    }
    if (1 < counter && counter > (numberOfLetters)) {
      image (name,0,0);
      image (verticalKeyboard,0,keyy);
      keyy+=20;
    }
  }
  
  ///////////////////////////////////////////////////
  //[3.12]Waving reeds animation/////////////////////
  ///////////////////////////////////////////////////
  
  if (start_reed_animation==true) {

    if (reed_frame<=29) {

      animated_reed= loadImage (("r"+ reed_frame)+".png");
      image (animated_reed, thisreedX, thisreedY);
      if(frameCount%5==0) {
        reed_frame+=1;
      }
    }
    if (reed_frame>=29) {
      present_reed1=true;
      present_reed2=true;
      present_reed3=true;
      present_reed4=true;
      present_reed5=true;
      start_reed_animation=false;
    }
  }
  if (level==see_level) {
    imhere_animate ();
  }
}


void mousePressed() {
  
  ///////////////////////////////////////////////////
  //[4.1]Map dragging function///////////////////////
  ///////////////////////////////////////////////////
  
  if(level == map_level) {
    mousePressedBackground();
  }


  if (level==0) {
    if (mouseX>30 &&mouseX<130 && mouseY>420 && mouseY<470) {
      level=login_level;
      fade=0;
    }
    if (mouseX>180 &&mouseX<300 && mouseY>420 && mouseY<470) {
      level=see_level;
      fade=0;
    }
  }
  
  ///////////////////////////////////////////////////
  //[4.2]Fake Keyboard///////////////////////////////
  ///////////////////////////////////////////////////
  
  if (level==login_level) {
    if (counter <= (numberOfLetters+1)) {
      counter+=1;
    }
    if (counter>=(numberOfLetters+2)&& mouseX>120 && mouseY>270 && mouseX<190 && mouseY<300) {
      fade=0;
      level+=1;
    }
  }

  ///////////////////////////////////////////////////
  //[4.3]Hear single whispers pressing the reeds/////
  ///////////////////////////////////////////////////
  
  if (level==see_level) {
    if (mouseX>150 && mouseX<170 && mouseY<200) {
      reed_frame=1;
      thisreedX=100;
      thisreedY=0;
      present_reed1=false;
      start_reed_animation=true;
      whisper3.rewind(); 
      whisper3.play();
    }
    if (mouseX>70 && mouseX<100 && mouseY<300 && mouseY>100) {
      reed_frame=1;
      thisreedX=30;
      thisreedY=100;
      present_reed2=false;
      start_reed_animation=true;
      whisper4.rewind(); 
      whisper4.play();
    }
    if (mouseX>240 && mouseX<270 && mouseY<250 && mouseY>50) {
      reed_frame=1;
      thisreedX=200;
      thisreedY=50;
      present_reed3=false;
      start_reed_animation=true;
      whisper2.rewind(); 
      whisper2.play();
    }
    if (added_reed==true && mouseX>140 && mouseX<160 && mouseY>200 && mouseY<400) {
      reed_frame=1;
      thisreedX=75;
      thisreedY=200;
      present_reed4=false;
      start_reed_animation=true;
      whisper1.rewind();
      whisper1.play();
    }
  }
  
  ///////////////////////////////////////////////////
  //[4.4]Re-hear the planted reed////////////////////
  ///////////////////////////////////////////////////
  
  if (level==born_reed) {
    if (mouseX>140 && mouseX<180 && mouseY>100 && mouseY<400) {
      reed_frame=1;
      thisreedX=85;
      thisreedY=120;
      present_reed5=false;
      start_reed_animation=true;
      whisper1.rewind();
      whisper1.play();
    }
    if (mouseX>180 &&mouseX<220 && mouseY>380 && mouseY<420) {
      level=see_level;
      added_reed=true;
    }
  }
  if (mouseX>100 &&mouseX<150 && mouseY>380 && mouseY<420) {
    level=see_level;
  }
  
  ///////////////////////////////////////////////////
  //[4.5]Buttons' functions//////////////////////////
  ///////////////////////////////////////////////////
  
  if (map_button==true && mouseX<100 && mouseY>420) {
    fade=0;
    float x_velocity = -1;
    level=map_level;
    loadBackground();
    createReed();
  }
  if (see_button==true && mouseX<220 && mouseY>420 && mouseX>100) {
    fade=0;
    level=see_level;
  }
  if (plant_button==true && mouseX>220 && mouseY>420) {
    fade=0;
    level=plant_level;
  }

  ///////////////////////////////////////////////////
  //[4.6]Reset visible buttons on level change///////
  ///////////////////////////////////////////////////
  
  plant_button=false;
  map_button=false;
  see_button=false;
}



void keyPressed () {
  
  ///////////////////////////////////////////////////
  //[5.1]Change application color////////////////////
  /////(now with different keys, but it's supposed///
  ////////to change according to weather)////////////
  
  if (key=='n') {
    weather= color  (98, 119, 193);
    plant_button=false;
    map_button=false;
    see_button=false;
    counter=0;
    keyy=480;
    level=0;
  }
  if (key=='b') {
    weather= color  (119, 119, 121);
    plant_button=false;
    map_button=false;
    see_button=false;
    counter=0;
    keyy=480;
    level=0;
  }
  if (key=='s') {
    weather= color  (255, 255, 209);
    plant_button=false;
    map_button=false;
    see_button=false;
    counter=0;
    keyy=480;
    level=0;
  }
  if (key=='g') {
    weather= color  (193, 255, 255);
    plant_button=false;
    map_button=false;
    see_button=false;
    counter=0;
    keyy=480;
    level=0;
  }
  if (key=='w') {
    weather= color  (255);
    plant_button=false;
    map_button=false;
    see_button=false;
    counter=0;
    keyy=480;
    level=0;
  }
  
  ///////////////////////////////////////////////////
  //[5.2]Switch to Augmented Reality/////////////////
  /////(now with the 'a' key, but it's supposed//////
  ////////to change with orientation function)///////
  
  if (level==see_level && key == 'a') {
    fade=0;
    level=augmented_level;
    plant_button=false;
    map_button=false;
    see_button=false;
  }
  if (level==augmented_level && fade==255 && key== 'a') {
    fade=0;
    level=see_level;
  }
  ///////////////////////////////////////////////////
  //[5.2]Switch to Augmented Reality/////////////////
  /////(now with the 'h' key, but it's supposed//////
  ////////to change with proximity function)/////////
  
  if ((level==see_level || level==augmented_level) && key == 'h' && fade==255) {
    whispers.rewind(); 
    whispers.play();
    if (added_reed==true) {
      whisper1.rewind();
      whisper1.play();
    }
  }
}

